<template>
  <v-container>
    <v-row justify="center">
      <v-dialog
          v-model="dialogPost"
          fullscreen
          hide-overlay
          transition="dialog-bottom-transition"
          :retain-focus="false"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn
              color="primary"
              dark
              v-bind="attrs"
              v-on="on"
          >
            Créer un Client
          </v-btn>
        </template>
        <v-card>
          <v-toolbar
              dark
              color="primary"
          >
            <v-btn
                icon
                dark
                @click="dialogPost = false"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-toolbar-title>Formulaire ajout Client</v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
          <div>
            <v-card>
              <v-card-title>
                <span class="headline">Client</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-form>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                            v-model="firstname"
                            label="Prénom*"
                            type="text"
                            required
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                            v-model="lastname"
                            label="Nom*"
                            type="text"
                            required
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-text-field
                            v-model="email"
                            label="Email*"
                            type="email"
                            required
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-form>
                </v-container>
                <small>*L'étoile indique les champs requis</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                    color="blue darken-1"
                    text
                    @click="dialogPost = false"
                >
                  Fermer la fenêtre
                </v-btn>
                <v-btn
                    color="blue darken-1"
                    @click="dialogPost = false; postClient();"
                >
                  Créer
                </v-btn>
              </v-card-actions>
            </v-card>
          </div>
        </v-card>
      </v-dialog>
    </v-row>
    <v-list>
      <v-list-item
          v-for="client in clients"
          :key="client.id"
      >
        <client-component
            :id="client.id"
            :lastname="client.lastname"
            :firstname="client.firstname"
            :email="client.email"
            :date_created="client.date_created"
            @updated="getClients"
        />
      </v-list-item>
    </v-list>
  </v-container>
</template>

<script>
import ClientComponent from "../components/ClientComponent";

export default {
  name: "Client",
  components: {ClientComponent},
  data(){
    return {
      dialogPost: false,
      dialogPatch: false,
      clients: [],
      lastname: '',
      firstname: '',
      id: '',
      email: '',
    }
  },
  mounted: function () {
    this.getClients()
  },
  methods: {
    getClients(){
      this.$axios.get('/clients')
          .then(response => {
            this.clients = response.data.map((client) => {
              return {
                ...client,
                date_created: new Date(client.date_created)
              }
            })
          })
          .catch((erreur) =>{
            console.log(erreur)
          })
    },

    postClient() {
      this.$axios.post('/clients', {
        firstname: this.firstname,
        lastname: this.lastname,
        email: this.email,
      }).then((response) => {
        this.getClients()
        this.firstname = response.data.msg
        this.lastname = response.data.msg
        this.email = response.data.msg
      }).catch((erreur) => {
        console.log(erreur)
      })
    },
  }
}
</script>

<style scoped>

</style>